Linux CXL
 help / color / mirror / Atom feed
From: Ira Weiny <ira.weiny@intel.com>
To: Vishal Verma <vishal.l.verma@intel.com>
Cc: Dave Jiang <dave.jiang@intel.com>,
	 Dan Williams <dan.j.williams@intel.com>,
	nvdimm@lists.linux.dev,  linux-cxl@vger.kernel.org,
	Ira Weiny <ira.weiny@intel.com>
Subject: [PATCH ndctl RESEND 1/2] ndctl/test: Add destroy region test
Date: Thu, 30 Nov 2023 20:06:13 -0800	[thread overview]
Message-ID: <20231130-fix-region-destroy-v1-1-7f916d2bd379@intel.com> (raw)
In-Reply-To: <20231130-fix-region-destroy-v1-0-7f916d2bd379@intel.com>

Commit 9399aa667ab0 ("cxl/region: Add -f option for disable-region")
introduced a regression when destroying a region.

Add a tests for destroying a region.

Cc: Dave Jiang <dave.jiang@intel.com>
Signed-off-by: Ira Weiny <ira.weiny@intel.com>
---
 test/cxl-destroy-region.sh | 76 ++++++++++++++++++++++++++++++++++++++++++++++
 test/meson.build           |  2 ++
 2 files changed, 78 insertions(+)

diff --git a/test/cxl-destroy-region.sh b/test/cxl-destroy-region.sh
new file mode 100644
index 000000000000..251720a98688
--- /dev/null
+++ b/test/cxl-destroy-region.sh
@@ -0,0 +1,76 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (C) 2023 Intel Corporation. All rights reserved.
+
+. $(dirname $0)/common
+
+rc=77
+
+set -ex
+
+trap 'err $LINENO' ERR
+
+check_prereq "jq"
+
+modprobe -r cxl_test
+modprobe cxl_test
+rc=1
+
+check_destroy_ram()
+{
+	mem=$1
+	decoder=$2
+
+	region=$($CXL create-region -d "$decoder" -m "$mem" | jq -r ".region")
+	if [ "$region" == "null" ]; then
+		err "$LINENO"
+	fi
+	$CXL enable-region "$region"
+
+	# default is memory is system-ram offline
+	$CXL disable-region $region
+	$CXL destroy-region $region
+}
+
+check_destroy_devdax()
+{
+	mem=$1
+	decoder=$2
+
+	region=$($CXL create-region -d "$decoder" -m "$mem" | jq -r ".region")
+	if [ "$region" == "null" ]; then
+		err "$LINENO"
+	fi
+	$CXL enable-region "$region"
+
+	dax=$($CXL list -X -r "$region" | jq -r ".[].daxregion.devices" | jq -r '.[].chardev')
+
+	$DAXCTL reconfigure-device -m devdax "$dax"
+
+	$CXL disable-region $region
+	$CXL destroy-region $region
+}
+
+# Find a memory device to create regions on to test the destroy
+readarray -t mems < <("$CXL" list -b cxl_test -M | jq -r '.[].memdev')
+for mem in ${mems[@]}; do
+        ramsize=$($CXL list -m $mem | jq -r '.[].ram_size')
+        if [ "$ramsize" == "null" ]; then
+                continue
+        fi
+        decoder=$($CXL list -b cxl_test -D -d root -m "$mem" |
+                  jq -r ".[] |
+                  select(.volatile_capable == true) |
+                  select(.nr_targets == 1) |
+                  select(.size >= ${ramsize}) |
+                  .decoder")
+        if [[ $decoder ]]; then
+		check_destroy_ram $mem $decoder
+		check_destroy_devdax $mem $decoder
+                break
+        fi
+done
+
+check_dmesg "$LINENO"
+
+modprobe -r cxl_test
diff --git a/test/meson.build b/test/meson.build
index 2706fa5d633c..126d663dfce2 100644
--- a/test/meson.build
+++ b/test/meson.build
@@ -158,6 +158,7 @@ cxl_xor_region = find_program('cxl-xor-region.sh')
 cxl_update_firmware = find_program('cxl-update-firmware.sh')
 cxl_events = find_program('cxl-events.sh')
 cxl_poison = find_program('cxl-poison.sh')
+cxl_destroy_region = find_program('cxl-destroy-region.sh')
 
 tests = [
   [ 'libndctl',               libndctl,		  'ndctl' ],
@@ -188,6 +189,7 @@ tests = [
   [ 'cxl-xor-region.sh',      cxl_xor_region,     'cxl'   ],
   [ 'cxl-events.sh',          cxl_events,         'cxl'   ],
   [ 'cxl-poison.sh',          cxl_poison,         'cxl'   ],
+  [ 'cxl-destroy-region.sh',  cxl_destroy_region, 'cxl'   ],
 ]
 
 if get_option('destructive').enabled()

-- 
2.42.0


  reply	other threads:[~2023-12-01  4:06 UTC|newest]

Thread overview: 10+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2023-12-01  4:06 [PATCH ndctl RESEND 0/2] ndctl: Fix ups for region destroy Ira Weiny
2023-12-01  4:06 ` Ira Weiny [this message]
2023-12-01 17:40   ` [PATCH ndctl RESEND 1/2] ndctl/test: Add destroy region test Dave Jiang
2023-12-01 19:39   ` Alison Schofield
2023-12-04 18:05     ` Ira Weiny
2023-12-04 20:42       ` Verma, Vishal L
2023-12-05 21:22         ` Ira Weiny
2023-12-06  3:00           ` Verma, Vishal L
2023-12-01  4:06 ` [PATCH ndctl RESEND 2/2] cxl/region: Fix memory device teardown in disable-region Ira Weiny
2023-12-01 17:39   ` Dave Jiang

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20231130-fix-region-destroy-v1-1-7f916d2bd379@intel.com \
    --to=ira.weiny@intel.com \
    --cc=dan.j.williams@intel.com \
    --cc=dave.jiang@intel.com \
    --cc=linux-cxl@vger.kernel.org \
    --cc=nvdimm@lists.linux.dev \
    --cc=vishal.l.verma@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox